Reminder: in case of any technical issues, you can use the lightweight website
m1.codeforces.com,
m2.codeforces.com,
m3.codeforces.com.
×

# | User | Rating |
---|---|---|

1 | tourist | 3557 |

2 | Um_nik | 3494 |

3 | Radewoosh | 3344 |

4 | wxhtxdy | 3309 |

5 | LHiC | 3302 |

6 | Benq | 3286 |

7 | mnbvmar | 3274 |

8 | Petr | 3254 |

9 | yutaka1999 | 3190 |

10 | ksun48 | 3170 |

# | User | Contrib. |
---|---|---|

1 | Errichto | 191 |

2 | Radewoosh | 180 |

3 | tourist | 165 |

3 | PikMike | 165 |

3 | antontrygubO_o | 165 |

3 | Vovuh | 165 |

7 | rng_58 | 160 |

8 | majk | 156 |

8 | Um_nik | 156 |

10 | 300iq | 155 |

↑

↓

Codeforces (c) Copyright 2010-2019 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Oct/16/2019 18:44:02 (e1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|

the input size if small (the largest factorial you will need is 20!) so here you can generate all the possible factorials and use bitmasking (or recursion) to pre-calculate all possible values and cache them ... then for every case you just output the answer

I pre-calculate all the value upto 20. But now i cant understand how can i find my desired number .

I have no idea about bitmasking. Is there any other way ?

Use brute-force. For each number there are two cases — to use or not to use :)

If i use brute-force, at some stage summation of fact(num) may exceed my desired n , at that case i may avoid that fact(num) . But can i surely say that at any stage summation of fact(num) will be equal to my desired n ?

I think that this approach will result in TLE since the limit is 0.5 :) I think it is better to read Caraz96's idea and ask if you misunderstood something in it.

It is possible to use a greedy approach: since fact(n) > fact(0)+fact(1)+...+fact(n-1) (this is true for each n > 2) you can iterate from the greatest factorial(20!) to the smallest one, if fact[i] is less than or equal to N you must take it, decrease N by fact[i] and proceed with the next factorial. At the end, if N is 0 you found the solution, otherwise it is impossible to obtain N adding factorials.

Thanks. Got AC.

Thank you! got ac :D

Exactly I started it today and I went totally in this way . As a very beginner I was amazed when I saw that other coders also think in the same way .